<?php

namespace Drupal\fxl_converge_gateway\Form;

use Drupal\Core\Form\FormBase;
use Drupal\Core\Form\FormStateInterface;
use Drupal\Core\Ajax\AjaxResponse;
use Drupal\fxl_converge_gateway\Ajax\ReadMessageCommand;
use Drupal\fxl_converge_gateway\Ajax\VoidButtonCommand;
use Drupal\fxl_converge_gateway\Ajax\ReturnButtonCommand;

class ConvergegatewayForm extends FormBase
{



  /**
   * Returns a unique string identifying the form.
   *
   * The returned ID should be a unique string that can be a valid PHP function
   * name, since it's used in hook implementation names such as
   * hook_form_FORM_ID_alter().
   *
   * @return string
   *   The unique string identifying the form.
   */
  public $ssl_first_name;
  public $ssl_last_name;
  public $ssl_email;
  public $ssl_avs_address;
  public $ssl_avs_zip;
  public $ssl_amount;
  public $token;
  public $field_transactionid;

   public function getFormId()
  {
    return 'convergegateway_form';
  }

  public function __construct($form_data_array = array())
  {
    $this->ssl_first_name = $form_data_array["firstName"];
    $this->ssl_last_name = $form_data_array["lastName"];
    $this->ssl_avs_address = $form_data_array["address"];
    $this->ssl_email = $form_data_array["email"];
    $this->ssl_avs_zip = $form_data_array["postal"];
    $this->ssl_amount = $form_data_array["grand_total"];
    $this->field_transactionid=$form_data_array["field_transactionid"];
  }

  public function buildForm(array $form, FormStateInterface $form_state)
  {
    global $base_url;

    $a = 1;

    $form["form"]['convergegateway_title'] = array(
      '#type' => 'markup',
      '#markup' => '<div id="form_outer_containerid"><div id="message_containerid"></div><h2>Converge Gateway</h2>',
      '#weight' => 10,

    );

    $form["form"]['ssl_first_name'] = array(
      '#name' => 'ssl_first_name',
      '#id' => 'ssl_first_nameid',
      '#type' => 'textfield',
      '#title' => t('First Name:'),
      '#required' => TRUE,
      '#default_value' => $this->ssl_first_name,
      '#weight' => 20,

    );

    $form["form"]['ssl_last_name'] = array(
      '#name' => 'ssl_last_name',
      '#id' => 'ssl_last_nameid',
      '#type' => 'textfield',
      '#title' => t('Last Name:'),
      '#required' => TRUE,
      '#default_value' => $this->ssl_last_name,
      '#weight' => 30,
    );

    $form["form"]['ssl_email'] = array(
      '#name' => 'ssl_email',
      '#id' => 'ssl_emailid',
      '#type' => 'email',
      '#title' => t('Email ID:'),
      '#required' => TRUE,
      '#default_value' => $this->ssl_email,
      '#weight' => 40,
    );

    $form["form"]['ssl_avs_address'] = array(
      '#name' => 'ssl_avs_address',
      '#id' => 'ssl_avs_addressid',
      '#type' => 'textfield',
      '#title' => t('Address1'),
      '#default_value' => $this->ssl_avs_address,
      '#required' => TRUE,
      '#weight' => 50,
    );

    $form["form"]['ssl_avs_zip'] = array(
      '#name' => 'ssl_avs_zip',
      '#id' => 'ssl_avs_zipid',
      '#type' => 'textfield',
      '#title' => 'Postal',
      '#required' => TRUE,
      '#default_value' => $this->ssl_avs_zip,
      '#weight' => 60,
    );

    $form["form"]['ssl_amount'] = array(
      '#name' => 'ssl_amount',
      '#id' => 'ssl_amountid',
      '#type' => 'textfield',
      '#title' => 'Amount',
      '#required' => TRUE,
      '#default_value' => $this->ssl_amount,
      '#weight' => 70,
    );


//field_transactionid

     // '#limit_validation_errors' => array(),
    if(empty($form["form"]['transaction_id'])) {
    // $form["form"]['actions']['#type'] = 'actions';
    $form["form"]['button'] = array(
      '#type' => 'button',
      '#value' => 'Pay Now',
      '#limit_validation_errors' => array(),
      '#ajax' => array(
        'callback' => [$this, 'modulename_add_more_callback'],
        'wrapper' => 'form_outer_containerid',

        'event' => 'click',

      ),
      '#suffix' => '',
      '#weight' => 80,

    );
  }

if(!isset($user_data_array["transaction_id"])) {
  // $form["form"]['actions']['#type'] = 'actions';
  $form["form"]['button_void'] = array(
    '#type' => 'button',
    '#value' => 'Void',
    '#limit_validation_errors' => array(),
    '#ajax' => array(
      'callback' => [$this, 'void_add_more_callback'],
      'wrapper' => 'form_outer_containerid',

      'event' => 'click',

    ),
    '#suffix' => '',
    '#weight' => 85,

  );
};



    // $form["form"]['actions']['#type'] = 'actions';
    $form["form"]['button_return'] = array(
      '#type' => 'button',
      '#value' => 'Return',
      '#limit_validation_errors' => array(),
      '#ajax' => array(
        'callback' => [$this, 'return_add_more_callback'],
        'wrapper' => 'form_outer_containerid',

        'event' => 'click',

      ),
      '#suffix' => '',
      '#weight' => 88,

    );
    $form["form"]["transaction_response"]=array(
         '#type' => 'markup',
         '#markup' => '<div id="reading-user-points"><div id="current-msg"><h2></h2><p></p></div></div>Transaction Status:<div id="txn_status"></div><br/>Transaction Response:<div id="txn_response"></div><br>Transaction ID:<div id="ssl_txn_id"></div>',
         '#weight' => 89
    );





    $form["form"]['token'] = array(
      '#name' => 'token',
      '#id' => 'tokenid',
      '#type' => 'textfield',
      '#title' => 'Token',
     
      '#weight' => 90,

    );

     $form["form"]['transaction_id'] = array(
      '#name' => 'transaction_id',
      '#id' => 'transaction_id',
      '#type' => 'textfield',
      '#title' => 'TransID',
      '#default_value' => $this->field_transactionid,
      '#weight' => 90,

    );

       $current_uri = \Drupal::request()->getRequestUri();
       $current_uri = $current_uri;


       $form["form"]['current_urid'] = array(
      '#name' => 'current_uri',
      '#id' => 'current_uriid',
      '#type' => 'hidden',
      '#title' => 'Token',
      '#value' => $current_uri,

      '#weight' => 90,

    );

    $form["form"]['nidid'] = array(
      '#name' => 'nidid',
      '#id' => 'nidid',
      '#type' => 'hidden',
      '#title' => 'Token',

      '#weight' => 90,

    );

    $form["form"]['base_url'] = array(
      '#name' => 'base_url',
      '#id' => 'base_url',
      '#type' => 'hidden',

      '#value' => $base_url,

      '#weight' => 90,

    );
    $form["form"]['button2'] = array(
      '#type' => 'button',
      '#value' => 'Enter Card',
      '#id'    => 'entercard_id',
      '#weight' => 100,
      '#attributes' => [
        'onclick' => 'return false;'
      ],
    );
    $form["form"]['form_end'] = array(
      '#type' => 'markup',
      '#markup' => '</div>',
      '#weight' => 210,

    );

    $form['#attached']['library'][] = 'fxl_converge_gateway/bootstrap-style';
    return $form;
  }

  function modulename_add_more_callback(array &$form, FormStateInterface $form_state)
  {
    // Something within the callback function.
    $forms_values = $form_state->getValues();

    $node = \Drupal::routeMatch()->getParameter('node');
    $message = $forms_values["ssl_first_name"] . '#' . $forms_values["ssl_last_name"];
    $user_data_array["ssl_first_name"] = $forms_values["ssl_first_name"];
    $user_data_array["ssl_last_name"] = $forms_values["ssl_last_name"];
    $user_data_array['ssl_email'] = $forms_values["ssl_email"];
    $user_data_array["ssl_avs_address"] = $forms_values["ssl_avs_address"];
    $user_data_array["ssl_avs_zip"] = $forms_values["ssl_avs_zip"];
    $user_data_array["ssl_amount"] = $forms_values["ssl_amount"];
    $user_data_array["nid"] =  $node->id();
    $current_uri = \Drupal::request()->getRequestUri();
    $user_data_array["current_uri"]=$current_uri;


    // Create AJAX Response object.
    $response = new AjaxResponse();
    // Call the readMessage javascript function.
    $response->addCommand(new ReadMessageCommand($user_data_array));

    // Return ajax response.
    return $response;
  }

  //Call void curl
  function void_add_more_callback(array &$form, FormStateInterface $form_state)
  {
    // Something within the callback function.
    $forms_values = $form_state->getValues();

    $node = \Drupal::routeMatch()->getParameter('node');


    $user_data_array["nid"] =  $node->id();
    $user_data_array["transaction_id"]  = $forms_values["transaction_id"]; //get token id ssl_txn_id @Sonu, see the CCvoidphp.php file in Asana to see the required curl parameters to issue a return
    $current_uri = \Drupal::request()->getRequestUri();
    $user_data_array["current_uri"]=$current_uri;


    // Create AJAX Response object.
    $response = new AjaxResponse();
    // Call the readMessage javascript function.
    $response->addCommand(new VoidButtonCommand($user_data_array));

    // Return ajax response.
    return $response;
  }

  //Call return curl
  function return_add_more_callback(array &$form, FormStateInterface $form_state)
  {
    // Something within the callback function.
    $forms_values = $form_state->getValues();

    $node = \Drupal::routeMatch()->getParameter('node');
    $user_data_array["nid"] =  $node->id();
    $user_data_array["transaction_id"]  = $forms_values["transaction_id"]; //get token id ssl_txn_id @Sonu, see the CCvoidphp.php file in Asana to see the required curl parameters to issue a return
    $user_data_array["ssl_amount"] = $forms_values["ssl_amount"];
      $current_uri = \Drupal::request()->getRequestUri();
    $user_data_array["current_uri"]=$current_uri;

    // Create AJAX Response object.
    $response = new AjaxResponse();
    // Call the readMessage javascript function.
    $response->addCommand(new ReturnButtonCommand($user_data_array));

    // Return ajax response.
    return $response;
  }

  public function submitForm(array &$form, FormStateInterface $form_state)
  {
    // drupal_set_message($this->t('@can_name ,Your application is being submitted!', array('@can_name' => $form_state->getValue('candidate_name'))));
    foreach ($form_state->getValues() as $key => $value) {
      drupal_set_message($key . ': ' . $value);
    }
  }
}
